diff -crN nakedmudv1.5/src/room.c nakedmudv2.0/src/room.c
*** nakedmudv1.5/src/room.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/room.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 23,31 ****
  #include "room.h"
  
  
! #ifdef MODULE_SCRIPTS
  #include "scripts/script.h"
! #endif
  
  
  // how many special exits do we expect to have?
--- 23,34 ----
  #include "room.h"
  
  
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "scripts/script.h"
! 
  
  
  // how many special exits do we expect to have?
***************
*** 38,44 ****
  
    int         terrain;           // what kind of terrain do we have?
    char       *name;              // what is the name of our room?
!   char       *desc;              // our description
  
    EDESC_SET  *edescs;            // the extra descriptions in the room
    EXIT_DATA **exits;             // the normal exists
--- 41,47 ----
  
    int         terrain;           // what kind of terrain do we have?
    char       *name;              // what is the name of our room?
!   BUFFER     *desc;              // our description
  
    EDESC_SET  *edescs;            // the extra descriptions in the room
    EXIT_DATA **exits;             // the normal exists
***************
*** 64,70 ****
    room->vnum = NOWHERE;
  
    room->name      = strdup("");
!   room->desc      = strdup("");
  
  
    room->terrain = TERRAIN_INDOORS;
--- 67,73 ----
    room->vnum = NOWHERE;
  
    room->name      = strdup("");
!   room->desc      = newBuffer(1);
  
  
    room->terrain = TERRAIN_INDOORS;
***************
*** 117,123 ****
  
    // delete strings
    if(room->name)        free(room->name);
!   if(room->desc)        free(room->desc);
    deleteAuxiliaryData(room->auxiliary_data);
  
    free(room);
--- 120,126 ----
  
    // delete strings
    if(room->name)        free(room->name);
!   if(room->desc)        deleteBuffer(room->desc);
    deleteAuxiliaryData(room->auxiliary_data);
  
    free(room);
***************
*** 127,133 ****
  STORAGE_SET *roomStore(ROOM_DATA *room) {
    STORAGE_SET *set = new_storage_set();
    store_string(set, "name",    room->name);
!   store_string(set, "desc",    room->desc);
    store_int   (set, "vnum",    room->vnum);
    store_int   (set, "terrain", room->terrain);
    store_set   (set, "edescs",  edescSetStore(room->edescs));
--- 130,136 ----
  STORAGE_SET *roomStore(ROOM_DATA *room) {
    STORAGE_SET *set = new_storage_set();
    store_string(set, "name",    room->name);
!   store_string(set, "desc",    bufferString(room->desc));
    store_int   (set, "vnum",    room->vnum);
    store_int   (set, "terrain", room->terrain);
    store_set   (set, "edescs",  edescSetStore(room->edescs));
***************
*** 212,218 ****
    roomSetTerrain (to, roomGetTerrain(from));
  
    // set our edescs
!   roomSetEdescs(to, copyEdescSet(from->edescs));
  
    // set our normal exits
    for(i = 0; i < NUM_DIRS; i++)
--- 215,221 ----
    roomSetTerrain (to, roomGetTerrain(from));
  
    // set our edescs
!   roomSetEdescs(to, edescSetCopy(from->edescs));
  
    // set our normal exits
    for(i = 0; i < NUM_DIRS; i++)
***************
*** 275,285 ****
  
  void roomReset(ROOM_DATA *room) {
    resetRunOn(room->reset, room, INITIATOR_ROOM);
- #ifdef MODULE_SCRIPTS
    try_scripts(SCRIPT_TYPE_INIT,
  	      room, SCRIPTOR_ROOM,
  	      NULL, NULL, room, NULL, NULL, 0);
- #endif
  }
  
  
--- 278,286 ----
***************
*** 340,351 ****
  };
  
  const char *roomGetDesc        (const ROOM_DATA *room) {
!   return room->desc;
  };
  
! char      **roomGetDescPtr     (ROOM_DATA *room) {
!   return &(room->desc);
! };
  
  int         roomGetTerrain     (const ROOM_DATA *room) {
    return room->terrain;
--- 341,352 ----
  };
  
  const char *roomGetDesc        (const ROOM_DATA *room) {
!   return bufferString(room->desc);
  };
  
! BUFFER *roomGetDescBuffer(const ROOM_DATA *room) {
!   return room->desc;
! }
  
  int         roomGetTerrain     (const ROOM_DATA *room) {
    return room->terrain;
***************
*** 378,385 ****
  }
  
  const char *roomGetEdesc       (const ROOM_DATA *room, const char *keyword) {
!   EDESC_DATA *edesc = getEdesc(room->edescs, keyword);
!   if(edesc) return getEdescDescription(edesc);
    else return NULL;
  }
  
--- 379,386 ----
  }
  
  const char *roomGetEdesc       (const ROOM_DATA *room, const char *keyword) {
!   EDESC_DATA *edesc = edescSetGet(room->edescs, keyword);
!   if(edesc) return edescSetGetDesc(edesc);
    else return NULL;
  }
  
***************
*** 402,409 ****
  };
  
  void        roomSetDesc (ROOM_DATA *room, const char *desc) {
!   if(room->desc) free(room->desc);
!   room->desc = strdup(desc ? desc : "");
  };
  
  void        roomSetTerrain     (ROOM_DATA *room, int terrain_type) {
--- 403,410 ----
  };
  
  void        roomSetDesc (ROOM_DATA *room, const char *desc) {
!   bufferClear(room->desc);
!   bufferCat(room->desc, (desc ? desc : ""));
  };
  
  void        roomSetTerrain     (ROOM_DATA *room, int terrain_type) {
diff -crN nakedmudv1.5/src/room.d nakedmudv2.0/src/room.d
*** nakedmudv1.5/src/room.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/room.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ room.d room.o: room.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h exit.h extra_descs.h utils.h handler.h \
+   character.h auxiliary.h storage.h room_reset.h room.h scripts/script.h
diff -crN nakedmudv1.5/src/room.h nakedmudv2.0/src/room.h
*** nakedmudv1.5/src/room.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/room.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 118,125 ****
  const char *roomGetName        (const ROOM_DATA *room);
  const char *roomGetDesc        (const ROOM_DATA *room);
  int         roomGetTerrain     (const ROOM_DATA *room);
!  // used for editing room descs with the text editor
! char      **roomGetDescPtr     (ROOM_DATA *room);
  
  EXIT_DATA  *roomGetExit         (const ROOM_DATA *room, int dir);
  EXIT_DATA  *roomGetExitSpecial  (const ROOM_DATA *room, const char *dir);
--- 118,124 ----
  const char *roomGetName        (const ROOM_DATA *room);
  const char *roomGetDesc        (const ROOM_DATA *room);
  int         roomGetTerrain     (const ROOM_DATA *room);
! BUFFER     *roomGetDescBuffer  (const ROOM_DATA *room);
  
  EXIT_DATA  *roomGetExit         (const ROOM_DATA *room, int dir);
  EXIT_DATA  *roomGetExitSpecial  (const ROOM_DATA *room, const char *dir);
diff -crN nakedmudv1.5/src/room_reset.c nakedmudv2.0/src/room_reset.c
*** nakedmudv1.5/src/room_reset.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/room_reset.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 19,28 ****
  #include "object.h"
  #include "exit.h"
  #include "handler.h"
- #include "items.h"
  #include "room_reset.h"
  
  
  struct reset_data {
    int        type; // what kind of reset are we?
    int       times; // how many times should it be executed?
--- 19,37 ----
  #include "object.h"
  #include "exit.h"
  #include "handler.h"
  #include "room_reset.h"
  
  
+ 
+ //*****************************************************************************
+ // mandatory modules
+ //*****************************************************************************
+ #include "items/items.h"
+ #include "items/container.h"
+ #include "items/furniture.h"
+ 
+ 
+ 
  struct reset_data {
    int        type; // what kind of reset are we?
    int       times; // how many times should it be executed?
***************
*** 336,342 ****
      char_to_room(mob, initiator);
    // to a seat
    else if(initiator_type == INITIATOR_ON_OBJ) {
!     if(objGetType(initiator) != ITEM_FURNITURE || objGetRoom(initiator)==NULL) {
        extract_mobile(mob);
        return FALSE;
      }
--- 345,351 ----
      char_to_room(mob, initiator);
    // to a seat
    else if(initiator_type == INITIATOR_ON_OBJ) {
!     if(!objIsType(initiator, "furniture") || objGetRoom(initiator)==NULL) {
        extract_mobile(mob);
        return FALSE;
      }
***************
*** 526,532 ****
      return TRUE;
    }
    else if(initiator_type == INITIATOR_THEN_OBJ) {
!     if(objGetType(initiator) != ITEM_CONTAINER)
        return FALSE;
      containerSetLocked(initiator, locked);
      containerSetClosed(initiator, closed);
--- 535,541 ----
      return TRUE;
    }
    else if(initiator_type == INITIATOR_THEN_OBJ) {
!     if(!objIsType(initiator, "container"))
        return FALSE;
      containerSetLocked(initiator, locked);
      containerSetClosed(initiator, closed);
diff -crN nakedmudv1.5/src/room_reset.d nakedmudv2.0/src/room_reset.d
*** nakedmudv1.5/src/room_reset.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/room_reset.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ room_reset.d room_reset.o: room_reset.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h storage.h room.h world.h \
+   character.h body.h object.h exit.h handler.h room_reset.h items/items.h \
+   items/container.h items/furniture.h
diff -crN nakedmudv1.5/src/save.d nakedmudv2.0/src/save.d
*** nakedmudv1.5/src/save.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/save.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ save.d save.o: save.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h character.h world.h utils.h handler.h body.h \
+   object.h room.h storage.h
diff -crN nakedmudv1.5/src/scripts/pychar.c nakedmudv2.0/src/scripts/pychar.c
*** nakedmudv1.5/src/scripts/pychar.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/scripts/pychar.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 15,21 ****
  #include "../room.h"
  #include "../character.h"
  #include "../object.h"
- #include "../items.h"
  #include "../races.h"
  #include "../handler.h"
  #include "../utils.h"
--- 15,20 ----
***************
*** 25,34 ****
  #include "pyroom.h"
  #include "pyobj.h"
  
! // optional modules
! #ifdef MODULE_CHAR_VARS
  #include "../char_vars/char_vars.h"
! #endif
  
  
  typedef struct {
--- 24,35 ----
  #include "pyroom.h"
  #include "pyobj.h"
  
! 
! //*****************************************************************************
! // mandatory modules
! //*****************************************************************************
  #include "../char_vars/char_vars.h"
! #include "../items/items.h"
  
  
  typedef struct {
***************
*** 115,120 ****
--- 116,147 ----
  
  
  //
+ // Send a newline-tagged message to everyone around the character
+ //
+ static PyObject *
+ PyChar_sendaround(PyChar *self, PyObject *value) {
+   char *mssg = NULL;
+   if (!PyArg_ParseTuple(value, "s", &mssg)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Characters may only be sent strings");
+     return NULL;
+   }
+ 
+   CHAR_DATA *ch = propertyTableGet(mob_table, self->uid);
+   if(ch) {
+     send_around_char(ch, FALSE, "%s\r\n", mssg);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+                     "Tried to send message to nonexistant character, %d.", 
+ 		    self->uid);
+     return NULL;
+   }
+ }
+ 
+ 
+ //
  // make the character perform an action
  //
  static PyObject *
***************
*** 141,147 ****
  }
  
  
- #ifdef MODULE_CHAR_VARS
  //
  // Get the value of a variable stored on the character
  //
--- 168,173 ----
***************
*** 213,233 ****
      return NULL;
    }
  }
- #endif
  
  
  
  static PyMethodDef PyChar_methods[] = {
      {"send", (PyCFunction)PyChar_send, METH_VARARGS,
       "send a message to the character." },
      {"act", (PyCFunction)PyChar_act, METH_VARARGS,
       "make the character perform an action." },
- #ifdef MODULE_CHAR_VARS
      {"getvar", (PyCFunction)PyChar_getvar, METH_VARARGS,
       "get the value of a special variable the character has."},
      {"setvar", (PyCFunction)PyChar_setvar, METH_VARARGS,
       "set the value of a special variable."},
- #endif
      {NULL}  /* Sentinel */
  };
  
--- 239,258 ----
      return NULL;
    }
  }
  
  
  
  static PyMethodDef PyChar_methods[] = {
      {"send", (PyCFunction)PyChar_send, METH_VARARGS,
       "send a message to the character." },
+     {"sendaround", (PyCFunction)PyChar_sendaround, METH_VARARGS,
+      "send a message to everyone around a character."},
      {"act", (PyCFunction)PyChar_act, METH_VARARGS,
       "make the character perform an action." },
      {"getvar", (PyCFunction)PyChar_getvar, METH_VARARGS,
       "get the value of a special variable the character has."},
      {"setvar", (PyCFunction)PyChar_setvar, METH_VARARGS,
       "set the value of a special variable."},
      {NULL}  /* Sentinel */
  };
  
***************
*** 470,476 ****
  		   charGetName(ch));
        return -1;
      }
!     else if(objGetType(obj) == ITEM_FURNITURE) {
        if(charGetFurniture(ch))
  	char_from_furniture(ch);
        char_to_furniture(ch, obj);
--- 495,501 ----
  		   charGetName(ch));
        return -1;
      }
!     else if(objIsType(obj, "furniture")) {
        if(charGetFurniture(ch))
  	char_from_furniture(ch);
        char_to_furniture(ch, obj);
diff -crN nakedmudv1.5/src/scripts/pychar.d nakedmudv2.0/src/scripts/pychar.d
*** nakedmudv1.5/src/scripts/pychar.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/pychar.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ scripts/pychar.d scripts/pychar.o: scripts/pychar.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h world.h room.h character.h \
+   object.h races.h handler.h utils.h scripts/script.h scripts/pychar.h \
+   scripts/pyroom.h scripts/pyobj.h char_vars/char_vars.h items/items.h
diff -crN nakedmudv1.5/src/scripts/pymud.d nakedmudv2.0/src/scripts/pymud.d
*** nakedmudv1.5/src/scripts/pymud.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/pymud.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ scripts/pymud.d scripts/pymud.o: scripts/pymud.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h scripts/script.h \
+   scripts/pyroom.h scripts/pychar.h scripts/pyobj.h
diff -crN nakedmudv1.5/src/scripts/pyobj.d nakedmudv2.0/src/scripts/pyobj.d
*** nakedmudv1.5/src/scripts/pyobj.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/pyobj.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ scripts/pyobj.d scripts/pyobj.o: scripts/pyobj.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h world.h room.h character.h \
+   object.h races.h handler.h utils.h scripts/script.h scripts/pychar.h \
+   scripts/pyroom.h scripts/pyobj.h
diff -crN nakedmudv1.5/src/scripts/pyroom.c nakedmudv2.0/src/scripts/pyroom.c
*** nakedmudv1.5/src/scripts/pyroom.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/scripts/pyroom.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 81,86 ****
--- 81,112 ----
  //*****************************************************************************
  
  //
+ // Send a newline-tagged message to everyone in the room
+ //
+ static PyObject *
+ PyRoom_send(PyRoom *self, PyObject *value) {
+   char *mssg = NULL;
+   if (!PyArg_ParseTuple(value, "s", &mssg)) {
+     PyErr_Format(PyExc_TypeError, 
+                     "Characters may only be sent strings");
+     return NULL;
+   }
+ 
+   ROOM_DATA *room = worldGetRoom(gameworld, self->vnum);
+   if(room) {
+     send_to_list(roomGetCharacters(room), "%s\r\n", mssg);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+                     "Tried to send message to nonexistant room, %d.", 
+ 		    self->vnum);
+     return NULL;
+   }
+ }
+ 
+ 
+ //
  // close a door in the specified direction
  //
  static PyObject *
***************
*** 309,314 ****
--- 335,342 ----
       "lock a door in the specified direction, closing it if it is open." },
      {"unlock", (PyCFunction)PyRoom_unlock, METH_VARARGS,
       "unlocks the door in the specified direction." },
+     {"send", (PyCFunction)PyRoom_send, METH_VARARGS,
+      "send a message to everyone in the room."},
      {NULL}  /* Sentinel */
  };
  
diff -crN nakedmudv1.5/src/scripts/pyroom.d nakedmudv2.0/src/scripts/pyroom.d
*** nakedmudv1.5/src/scripts/pyroom.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/pyroom.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,4 ----
+ scripts/pyroom.d scripts/pyroom.o: scripts/pyroom.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h world.h room.h exit.h \
+   character.h races.h handler.h utils.h scripts/script.h scripts/pyroom.h \
+   scripts/pychar.h scripts/pyobj.h
diff -crN nakedmudv1.5/src/scripts/script.c nakedmudv2.0/src/scripts/script.c
*** nakedmudv1.5/src/scripts/script.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/scripts/script.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 10,15 ****
--- 10,19 ----
  // script stuff
  #include <Python.h>
  #include <structmember.h>
+ #include <compile.h>
+ #include <eval.h>
+ #include <node.h>
+ //PyAPI_FUNC(PyObject *) PyEval_EvalCode(PyCodeObject *, PyObject *, PyObject *);
  
  // mud stuff
  #include "../mud.h"
***************
*** 28,33 ****
--- 32,42 ----
  #include "pyobj.h"
  #include "pymud.h"
  
+ // online editor stuff
+ #include "../editor/editor.h"
+ #include "script_editor.h"
+ #include "../olc2/olc.h"
+ 
  
  
  //*****************************************************************************
***************
*** 144,150 ****
    char       *name;
    char       *args;
    int      num_arg;
!   char       *code;
  };
  
  const char *script_type_info[NUM_SCRIPTS] = {
--- 153,159 ----
    char       *name;
    char       *args;
    int      num_arg;
!   BUFFER     *code;
  };
  
  const char *script_type_info[NUM_SCRIPTS] = {
***************
*** 171,197 ****
    script->num_arg = 0;
    script->name    = strdup("");
    script->args    = strdup("");
!   script->code    = strdup("");
    return script;
  }
  
  void         deleteScript(SCRIPT_DATA *script) {
    if(script->name) free(script->name);
    if(script->args) free(script->args);
!   if(script->code) free(script->code);
    free(script);
  }
  
  SCRIPT_DATA *scriptRead(STORAGE_SET *set) {
!   SCRIPT_DATA *script = malloc(sizeof(SCRIPT_DATA));
!   script->vnum    = read_int(set, "vnum");
!   script->type    = read_int(set, "type");
!   script->num_arg = read_int(set, "narg");
!   script->name    = strdup(read_string(set, "name"));
!   script->args    = strdup(read_string(set, "args"));
!   script->code    = strdup(read_string(set, "code"));
    // python chokes on carraige returns. Strip 'em
!   format_script(&script->code, MAX_SCRIPT);
    return script;
  }
  
--- 180,206 ----
    script->num_arg = 0;
    script->name    = strdup("");
    script->args    = strdup("");
!   script->code    = newBuffer(1);
    return script;
  }
  
  void         deleteScript(SCRIPT_DATA *script) {
    if(script->name) free(script->name);
    if(script->args) free(script->args);
!   if(script->code) deleteBuffer(script->code);
    free(script);
  }
  
  SCRIPT_DATA *scriptRead(STORAGE_SET *set) {
!   SCRIPT_DATA *script = newScript();
!   scriptSetVnum(script, read_int(set, "vnum"));
!   scriptSetType(script, read_int(set, "type"));
!   scriptSetNumArg(script, read_int(set, "narg"));
!   scriptSetName(script, read_string(set, "name"));
!   scriptSetArgs(script, read_string(set, "args"));
!   scriptSetCode(script, read_string(set, "code"));
    // python chokes on carraige returns. Strip 'em
!   bufferReplace(script->code, "\r", "", TRUE);
    return script;
  }
  
***************
*** 202,208 ****
    store_int   (set, "narg", script->num_arg);
    store_string(set, "name", script->name);
    store_string(set, "args", script->args);
!   store_string(set, "code", script->code);
    return set;
  }
  
--- 211,217 ----
    store_int   (set, "narg", script->num_arg);
    store_string(set, "name", script->name);
    store_string(set, "args", script->args);
!   store_string(set, "code", bufferString(script->code));
    return set;
  }
  
***************
*** 216,226 ****
  void         scriptCopyTo(SCRIPT_DATA *from, SCRIPT_DATA *to) {
    if(to->name) free(to->name);
    if(to->args) free(to->args);
-   if(to->code) free(to->code);
  
    to->name = strdup(from->name ? from->name : "");
    to->args = strdup(from->args ? from->args : "");
!   to->code = strdup(from->code ? from->code : "");
    
    to->vnum    = from->vnum;
    to->type    = from->type;
--- 225,234 ----
  void         scriptCopyTo(SCRIPT_DATA *from, SCRIPT_DATA *to) {
    if(to->name) free(to->name);
    if(to->args) free(to->args);
  
    to->name = strdup(from->name ? from->name : "");
    to->args = strdup(from->args ? from->args : "");
!   bufferCopyTo(from->code, to->code);
    
    to->vnum    = from->vnum;
    to->type    = from->type;
***************
*** 248,258 ****
  }
  
  const char *scriptGetCode(SCRIPT_DATA *script) {
!   return script->code;
  }
  
! char      **scriptGetCodePtr(SCRIPT_DATA *script) {
!   return &(script->code);
  }
  
  void scriptSetVnum(SCRIPT_DATA *script, script_vnum vnum) {
--- 256,266 ----
  }
  
  const char *scriptGetCode(SCRIPT_DATA *script) {
!   return bufferString(script->code);
  }
  
! BUFFER *scriptGetCodeBuffer(SCRIPT_DATA *script) {
!   return script->code;
  }
  
  void scriptSetVnum(SCRIPT_DATA *script, script_vnum vnum) {
***************
*** 278,285 ****
  }
  
  void scriptSetCode(SCRIPT_DATA *script, const char *code) {
!   if(script->code) free(script->code);
!   script->code = strdup(code ? code : "");
  }
  
  
--- 286,293 ----
  }
  
  void scriptSetCode(SCRIPT_DATA *script, const char *code) {
!   bufferClear(script->code);
!   bufferCat(script->code, code);
  }
  
  
***************
*** 295,318 ****
  // eachother, we could get tossed into an infinite loop. He suggested a
  // check for loop depth before each script is run. If we are deeper than
  // some maximum depth, do not run the script.
- // 
  #define MAX_LOOP_DEPTH   30
  int script_loop_depth   = 0;
  
  
  //
! // Toss a script into Python and let it run
  //
! void start_script(char *script) {
!   script_loop_depth++;
!   // we exited with an error! Log it
!   if(script_loop_depth <= MAX_LOOP_DEPTH && PyRun_SimpleString(script) < 0) {
!     // hmmmm... there's gotta be a way we can get 
!     // the termination messages generated from running
!     log_string("script terminated with an error:\r\n"
! 	       "%s\r\n", script);
    }
-   script_loop_depth--;
  }
  
  
--- 303,436 ----
  // eachother, we could get tossed into an infinite loop. He suggested a
  // check for loop depth before each script is run. If we are deeper than
  // some maximum depth, do not run the script.
  #define MAX_LOOP_DEPTH   30
  int script_loop_depth   = 0;
  
  
  //
! // Python makes it overly complicated (IMO) to get traceback information when
! // running in C. I spent some time hunting around, and came across a lovely
! // site that provided me with this function for getting a traceback of an error.
! // The site that provided this piece of code to me is located here:
! //   http://stompstompstomp.com/weblog/technical/2004-03-29
! char* getPythonTraceback()
! {
!     // Python equivilant:
!     // import traceback, sys
!     // return "".join(traceback.format_exception(sys.exc_type, 
!     //    sys.exc_value, sys.exc_traceback))
! 
!     PyObject *type, *value, *traceback;
!     PyObject *tracebackModule;
!     char *chrRetval;
! 
!     PyErr_Fetch(&type, &value, &traceback);
! 
!     tracebackModule = PyImport_ImportModule("traceback");
!     if (tracebackModule != NULL)
!     {
!         PyObject *tbList, *emptyString, *strRetval;
! 
!         tbList = PyObject_CallMethod(
!             tracebackModule, 
!             "format_exception", 
!             "OOO",
!             type,
!             value == NULL ? Py_None : value,
!             traceback == NULL ? Py_None : traceback);
! 
!         emptyString = PyString_FromString("");
!         strRetval = PyObject_CallMethod(emptyString, "join", 
!             "O", tbList);
! 
!         chrRetval = strdup(PyString_AsString(strRetval));
! 
!         Py_DECREF(tbList);
!         Py_DECREF(emptyString);
!         Py_DECREF(strRetval);
!         Py_DECREF(tracebackModule);
!     }
!     else
!     {
!         chrRetval = strdup("Unable to import traceback module.");
!     }
! 
!     Py_DECREF(type);
!     Py_XDECREF(value);
!     Py_XDECREF(traceback);
! 
!     return chrRetval;
! }
! 
! 
  //
! // Return a new dictionary with all the basic modules imported
! PyObject *newScriptDict() {
!   PyObject* dict = PyDict_New();
!   
!   // Check for __builtins__...
!   if (PyDict_GetItemString(dict, "__builtins__") == NULL) {
!     // Hm... no __builtins__ eh?
!     PyObject* builtinMod = PyImport_ImportModule("__builtin__");
!     if (builtinMod == NULL || 
! 	PyDict_SetItemString(dict, "__builtins__", builtinMod) != 0) {
!       Py_DECREF(dict);
!       Py_XDECREF(dict);
!       // error handling
!       return NULL;
!     }
!     Py_DECREF(builtinMod);
!   }
! 
!   PyObject *sys = PyImport_ImportModule("sys");
!   if(sys != NULL) {
!     PyObject *exit = PyDict_GetItemString(PyModule_GetDict(sys), "exit");
!     if(exit != NULL)
!       PyDict_SetItemString(dict, "exit", exit);
!     Py_DECREF(sys);
!   }
!   
!   // merge all of the mud module contents with our current dict
!   PyObject *mudmod = PyImport_ImportModule("mud");
!   PyDict_Update(dict, PyModule_GetDict(mudmod));
!   Py_DECREF(mudmod);
!   mudmod = PyImport_ImportModule("char");
!   PyDict_Update(dict, PyModule_GetDict(mudmod));
!   Py_DECREF(mudmod);
!   mudmod = PyImport_ImportModule("room");
!   PyDict_Update(dict, PyModule_GetDict(mudmod));
!   Py_DECREF(mudmod);
!   mudmod = PyImport_ImportModule("obj");
!   PyDict_Update(dict, PyModule_GetDict(mudmod));
!   Py_DECREF(mudmod);
! 
!   return dict;
! }
! 
! 
! //
! // Decrement the reference count of the dictionary
! void deleteScriptDict(PyObject *dict) {
!   Py_DECREF(dict);
! }
! 
! 
! //
! // Toss a script into Python and let it run
! void start_script(PyObject *dict, const char *script) {
!   if(script_loop_depth < MAX_LOOP_DEPTH) {
!     script_loop_depth++;
!     PyObject* compileRetval = PyRun_String(script, Py_file_input, dict, dict);
!     script_loop_depth--;
!     // we threw an error and it wasn't an intentional
!     // system exit error. Now print the backtrace
!     if(compileRetval == NULL && PyErr_Occurred() != PyExc_SystemExit) {
!       char *tb = getPythonTraceback();
!       log_string("script terminated with an error:\r\n%s\r\n"
! 		 "\r\nTraceback is:\r\n%s\r\n", script, tb);
!       free(tb);
!     }
    }
  }
  
  
***************
*** 334,339 ****
--- 452,463 ----
  				       newScriptAuxData, deleteScriptAuxData,
  				       scriptAuxDataCopyTo, scriptAuxDataCopy,
  				       scriptAuxDataStore, scriptAuxDataRead));
+ 
+   extern COMMAND(cmd_scedit); // define the command
+   add_cmd("scedit", NULL, cmd_scedit, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_SCRIPTER, FALSE, TRUE);
+ 
+   init_script_editor();
  }
  
  
***************
*** 345,388 ****
  void run_script(const char *script, void *me, int me_type,
  		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, 
  		const char *cmd, const char *arg, int narg) {
!   static char buf[MAX_SCRIPT];
!   *buf = '\0';
!   int i = 0;
! 
!   // cat all of the headers
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from mud import *\n");
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from char import *\n");
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from room import *\n");
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from obj import *\n");
! 
!   // print the different variables
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "cmd = '%s'\n", (cmd ? cmd : ""));
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "arg = '%s'\n", (arg ? arg : ""));
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "narg = %d\n", narg);
! 
!   // print me
!   if(me_type == SCRIPTOR_CHAR)
!     i += snprintf(buf+i, MAX_SCRIPT - i - 1, "me = Char(%d)\n", charGetUID(me));
!   else if(me_type == SCRIPTOR_OBJ)
!     i += snprintf(buf+i, MAX_SCRIPT - i - 1, "me = Obj(%d)\n", objGetUID(me));
!   else if(me_type == SCRIPTOR_ROOM)
!     i += snprintf(buf+i, MAX_SCRIPT - i - 1, "me = Room(%d)\n",roomGetVnum(me));
! 
!   // print all of the other things involved
!   if(ch)
!     i += snprintf(buf+i, MAX_SCRIPT - i - 1, "ch = Char(%d)\n", charGetUID(ch));
!   if(obj)
!     i += snprintf(buf+i, MAX_SCRIPT - i - 1, "obj = Obj(%d)\n", objGetUID(obj));
!   if(room)
!     i += snprintf(buf+i, MAX_SCRIPT - i - 1, "room = Room(%d)\n", roomGetVnum(room));
!   if(exit)
!     ;
  
!   // cat the code
!   i += snprintf(buf+i, MAX_SCRIPT - i - 1, "%s", script);
  
    // start the script
!   start_script(buf);
  }
  
  
--- 469,522 ----
  void run_script(const char *script, void *me, int me_type,
  		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, 
  		const char *cmd, const char *arg, int narg) {
!   PyObject *dict = newScriptDict();
!   // now, import all of our command and argument variables
!   if(cmd) {
!     PyObject *pycmd = PyString_FromString(cmd);
!     PyDict_SetItemString(dict, "cmd", pycmd);
!     Py_DECREF(pycmd);
!   }
!   if(arg) {
!     PyObject *pyarg = PyString_FromString(arg);
!     PyDict_SetItemString(dict, "arg", pyarg);
!     Py_DECREF(pyarg);
!   }
!   if(TRUE) {
!     PyObject *pynarg = PyInt_FromLong(narg);
!     PyDict_SetItemString(dict, "narg", pynarg);
!     Py_DECREF(pynarg);
!   }
  
!   // now import everyone who is involved
!   if(me) {
!     PyObject *pyme = NULL;
!     switch(me_type) {
!     case SCRIPTOR_CHAR:  pyme = newPyChar(me); break;
!     case SCRIPTOR_OBJ:   pyme = newPyObj(me);  break;
!     case SCRIPTOR_ROOM:  pyme = newPyRoom(me); break;
!     }
!     PyDict_SetItemString(dict, "me", pyme);
!     Py_DECREF(pyme);
!   }
!   if(ch) {
!     PyObject *pych = newPyChar(ch);
!     PyDict_SetItemString(dict, "ch", pych);
!     Py_DECREF(pych);
!   }
!   if(room) {
!     PyObject *pyroom = newPyRoom(room);
!     PyDict_SetItemString(dict, "room", pyroom);
!     Py_DECREF(pyroom);
!   }    
!   if(obj) {
!     PyObject *pyobj = newPyObj(obj);
!     PyDict_SetItemString(dict, "obj", pyobj);
!     Py_DECREF(pyobj);
!   }    
  
    // start the script
!   start_script(dict, script);
!   deleteScriptDict(dict);
  }
  
  
diff -crN nakedmudv1.5/src/scripts/script.d nakedmudv2.0/src/scripts/script.d
*** nakedmudv1.5/src/scripts/script.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/scripts/script.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,5 ----
+ scripts/script.d scripts/script.o: scripts/script.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h socket.h character.h \
+   room.h object.h storage.h auxiliary.h scripts/script.h \
+   scripts/script_set.h scripts/pychar.h scripts/pyroom.h scripts/pyobj.h \
+   scripts/pymud.h editor/editor.h scripts/script_editor.h olc2/olc.h
